/*
 * Copyright 2001-2007, Haiku, Inc.
 * Copyright (c) 2003-4 Kian Duffy <myob@users.sourceforge.net>
 * Parts Copyright (C) 1998,99 Kazuho Okui and Takashi Murai. 
 * Distributed under the terms of the MIT license.
 */
#include <Rect.h>
#include <View.h>
#include <Message.h>
#include <TextControl.h>
#include <Button.h>

#include "SetTitleDlg.h"
#include "TermConst.h"
#include "TermWindow.h"


SetTitleDlg::SetTitleDlg (BRect frame, TermWindow *termWin)
  : BWindow(frame, "Change Terminal Title",
	    B_FLOATING_WINDOW_LOOK, B_FLOATING_APP_WINDOW_FEEL,
	    B_NOT_RESIZABLE|B_NOT_ZOOMABLE)
{

	fParentWin = termWin;
	fParentView = fParentWin->_ActiveTermView();
	
	// Add a view to this dialog window
	BView *top = new BView(Bounds(), "topview", B_FOLLOW_NONE, B_WILL_DRAW);
  	top->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
  	AddChild (top);
	
	// Add a text control to the view for entering the new title
    BRect r(-50,10,230,50);
	textCtl = new BTextControl(r, "", "Title:", "", NULL);
	textCtl->SetAlignment(B_ALIGN_RIGHT,B_ALIGN_LEFT);
    top->AddChild (textCtl);
    textCtl->MakeFocus(true);
    
   	// Add an Ok button to the view for confirming the new title
    BButton *bOK_CHANGE_WIN_TITLE;
    BRect rBTN(150,60,240,90);
  	bOK_CHANGE_WIN_TITLE = new BButton(rBTN, "", "Ok", new BMessage(MSG_OK_CHANGE_TITLE));
  	top->AddChild(bOK_CHANGE_WIN_TITLE);
	bOK_CHANGE_WIN_TITLE->ResizeToPreferred();

    this->SetDefaultButton(bOK_CHANGE_WIN_TITLE);
	this->SetTitle ("Change Terminal Title");
	this->Show();

}

void
SetTitleDlg::MessageReceived(BMessage *msg)
{
  switch (msg->what) {  
  case MSG_OK_CHANGE_TITLE:
  	fParentView->SetTitle(textCtl->Text());
    Quit();
    break;
    
  default:
    BWindow::MessageReceived(msg);
    break;      
  }
}


SetTitleDlg::~SetTitleDlg (void)
{
  
}

void
SetTitleDlg::Quit (void)
{
  fParentWin->PostMessage (MSG_SET_TITLE_CLOSED);
  BWindow::Quit ();
}

